// Delay program to help with autoload script and shutdown stuff
// Author: Sam Torno
// Do what you want with this... I really don't care :D

#include <iostream.h>
#include <time.h>
#include <conio.h>
#include <windows.h>

void Usage(HANDLE hCon);

int main(int argc, char **argv)
{
	HANDLE hConsole = GetStdHandle(STD_OUTPUT_HANDLE);
	
	if(argc == 4)
	{
		time_t ltime;
		time(&ltime);
		long double start = ltime, now = ltime;
		long double delay, lastsec = now;
		COORD pos;

		if(!isdigit(*argv[1]) || !isdigit(*argv[2]) || !isdigit(*argv[3]))
		{
			cout << "Digits only please!" << endl;
			Usage(hConsole);
			return 0;
		} 
		else if((atoi(argv[1]) < 0 || atoi(argv[1]) > 999) || (atoi(argv[2]) < 0) || (atoi(argv[3]) < 0)) 
		{
			cout << "Invalid Inputs... (must be positive) and delay must be less then 1000" << endl;
			Usage(hConsole);
			return 0;
		}
		
		delay = (long double)atof(argv[1]);
		pos.X = atoi(argv[2]);
		pos.Y = atoi(argv[3]);

		while(now - start <= delay)
		{
			if(now != lastsec)
			{
				SetConsoleCursorPosition(hConsole, pos);
				cout << "   " << endl;
				SetConsoleCursorPosition(hConsole, pos);
				cout << delay - (now - start) << flush;
				lastsec = now;
			}
			time(&ltime);
			now = ltime;
		}
		return 0;
	}
	else
	{
		Usage(hConsole);
		return 0;
	}
}

void Usage(HANDLE hCon)
{
		SetConsoleTextAttribute(hCon,  FOREGROUND_GREEN | FOREGROUND_BLUE);
		cout << "Program usage:" << endl;
		cout << "--------------" << endl;
		SetConsoleTextAttribute(hCon,  FOREGROUND_GREEN);
		cout << "delay.exe <delay in seconds> <countdown x pos> <countdown y pos>" << endl;
		SetConsoleTextAttribute(hCon, FOREGROUND_RED | FOREGROUND_GREEN | FOREGROUND_BLUE);
}	